Index: trunk/src/VBox/Additions/linux/installer/vboxadd-service.sh
===================================================================
--- trunk/src/VBox/Additions/linux/installer/vboxadd-service.sh	(revision 58324)
+++ trunk/src/VBox/Additions/linux/installer/vboxadd-service.sh	(revision 58326)
@@ -27,5 +27,5 @@
 
 PATH=$PATH:/bin:/sbin:/usr/sbin
-SCRIPTNAME=vboxadd-service
+SCRIPTNAME=vboxadd-service.sh
 
 PIDFILE="/var/run/${SCRIPTNAME}"
@@ -39,16 +39,16 @@
 {
     test -n "${2}" && echo "${SCRIPTNAME}: ${1}."
-    logger "${SCRIPTNAME}: ${1}."
+    logger -t "${SCRIPTNAME}" "${1}."
 }
 
 succ_msg()
 {
-    logger "${SCRIPTNAME}: done."
+    logger -t "${SCRIPTNAME}" "${1}."
 }
 
 fail_msg()
 {
-    echo "${SCRIPTNAME}: failed." >&2
-    logger "${SCRIPTNAME}: failed."
+    echo "${SCRIPTNAME}: ${1}." >&2
+    logger -t "${SCRIPTNAME}" "${1}."
 }
 
@@ -95,5 +95,5 @@
         daemon $binary --pidfile $PIDFILE > /dev/null
         RETVAL=$?
-        succ_msg
+        succ_msg "VirtualBox Guest Addition service started"
     fi
     return $RETVAL
@@ -107,7 +107,7 @@
         if ! pidof VBoxService > /dev/null 2>&1; then
             rm -f $PIDFILE
-            succ_msg
+            succ_msg "VirtualBox Guest Addition service stopped"
         else
-            fail_msg
+            fail_msg "VirtualBox Guest Addition service failed to stop"
         fi
     fi
Index: trunk/src/VBox/Additions/linux/installer/vboxadd-x11.sh
===================================================================
--- trunk/src/VBox/Additions/linux/installer/vboxadd-x11.sh	(revision 58324)
+++ trunk/src/VBox/Additions/linux/installer/vboxadd-x11.sh	(revision 58326)
@@ -33,5 +33,5 @@
 CONFIG_DIR="/var/lib/VBoxGuestAdditions"
 CONFIG="config"
-SCRIPTNAME=vboxadd-x11
+SCRIPTNAME=vboxadd-x11.sh
 
 # Check architecture
@@ -78,16 +78,16 @@
 {
     test -n "${2}" && echo "${SCRIPTNAME}: ${1}."
-    logger "${SCRIPTNAME}: ${1}."
+    logger -t "${SCRIPTNAME}" "${1}."
 }
 
 succ_msg()
 {
-    logger "${SCRIPTNAME}: done."
+    logger -t "${SCRIPTNAME}" "${1}."
 }
 
 fail_msg()
 {
-    echo "${SCRIPTNAME}: failed." >&2
-    logger "${SCRIPTNAME}: failed."
+    echo "${SCRIPTNAME}: ${1}." >&2
+    logger -t "${SCRIPTNAME}" "${1}."
 }
 
@@ -377,5 +377,5 @@
         ln -s "$lib_dir/$vboxmouse_src" "$modules_dir/input/vboxmouse_drv$driver_ext";;
     esac
-    succ_msg
+    succ_msg "$xserver_version modules installed"
 
     if test -n "$dox11config"; then
@@ -418,5 +418,5 @@
             fi
         fi
-        succ_msg
+        succ_msg "Window System set up to use the Guest Additions"
         test -n "$generated" &&
             cat << EOF
@@ -476,5 +476,5 @@
         fail "See the log file $LOG for more information."
     ln -s "$lib_dir/98vboxadd-xclient" /usr/bin/VBoxClient-all 2>/dev/null
-    succ_msg
+    succ_msg "Window system drivers installed"
 }
 
Index: trunk/src/VBox/Additions/linux/installer/vboxadd.sh
===================================================================
--- trunk/src/VBox/Additions/linux/installer/vboxadd.sh	(revision 58324)
+++ trunk/src/VBox/Additions/linux/installer/vboxadd.sh	(revision 58326)
@@ -34,5 +34,5 @@
 MODPROBE=/sbin/modprobe
 OLDMODULES="vboxguest vboxadd vboxsf vboxvfs vboxvideo"
-SCRIPTNAME=vboxadd
+SCRIPTNAME=vboxadd.sh
 
 if $MODPROBE -c 2>/dev/null | grep -q '^allow_unsupported_modules  *0'; then
@@ -67,16 +67,10 @@
 {
     test -n "${2}" && echo "${SCRIPTNAME}: ${1}."
-    logger "${SCRIPTNAME}: ${1}."
+    logger -t "${SCRIPTNAME}" "${1}."
 }
 
 succ_msg()
 {
-    logger "${SCRIPTNAME}: done."
-}
-
-fail_msg()
-{
-    echo "${SCRIPTNAME}: failed." >&2
-    logger "${SCRIPTNAME}: failed."
+    logger -t "${SCRIPTNAME}" "${1}."
 }
 
@@ -84,5 +78,5 @@
 {
     echo "${SCRIPTNAME}: failed: ${1}." >&2
-    logger "${SCRIPTNAME}: ${1}."
+    logger -t "${SCRIPTNAME}" "${1}."
 }
 
@@ -230,7 +224,6 @@
         $MODPROBE vboxsf > /dev/null 2>&1 || {
             if dmesg | grep "vboxConnect failed" > /dev/null 2>&1; then
-                fail_msg
-                echo "Unable to start shared folders support.  Make sure that your VirtualBox build"
-                echo "supports this feature."
+                show_error "Unable to start shared folders support.  Make sure that your VirtualBox build"
+                show_error "supports this feature."
                 exit 1
             fi